
% This program solves (3.10) by the Newton's Method

function lambda0 = lambda310(epsilon,z,gamma,lblambda,ublambda);

% Initial guess of lambda:
lambda0 = 0;

dif = 1;
while dif > 1e-12,

    g = sum( abs(z).^2 ./ (1 + lambda0*gamma).^2 );
    f = g - epsilon;
    
    f_der = -2 * sum( gamma.*(abs(z).^2) ./...
        (1+lambda0*gamma).^3 );
    
    lambda1 = lambda0 - f/f_der;
    dif = abs(lambda1 - lambda0);
    lambda0 = lambda1;

end

% IS IT WORKING?
%g = sum( abs(z).^2 ./ (1 + lambda0*gamma).^2 );
%f = g - epsilon

if (lambda0 < lblambda) | (lambda0 > ublambda),
    lambda0 = NaN;
end

% -------------------------------------------------------------
