
% This program solves (3.19) by the Newton's Method

function [lambda0]=lambda319(M,zeta,z,Gamma,lblambda,ublambda);

% Initial guess of lambda:
lambda0 = 0;

dif = 1;
while dif > 1e-9,

    numerator = sum( abs(z).^2 ./ (Gamma + lambda0).^2 );
    denominator = (sum( abs(z).^2 ./ (Gamma + lambda0) )).^2;
    f = numerator/denominator - zeta;
    
    num_der = -2 * sum( abs(z).^2 ./ (Gamma + lambda0).^3 );
    den_der = 2 * sum( abs(z).^2 ./ (Gamma +lambda0) ) * ...
        ( -sum( abs(z).^2 ./ (Gamma + lambda0).^2 ) );
    f_der = ( num_der*denominator - numerator*den_der )...
        / denominator^2;
    
    lambda1 = lambda0 - f/f_der;
    dif = abs(lambda1 - lambda0);
    lambda0 = lambda1;

end

% IS IT WORKING?
%numerator = sum( abs(z).^2 / (Gamma + lambda0).^2 );
%denominator = (sum( abs(z).^2 / (Gamma + lambda0) )).^2;
%f = numerator/denominator - zeta

if (lambda0 < lblambda) | (lambda0 > ublambda),
    lambda0 = NaN;
end

% -------------------------------------------------------------
