
% This program solves (3.29) by the Newton's Method

function [lambda0]=lambda329(M,rho,z,iGamma,lblambda,ublambda);

% Initial guess of lambda:
lambda0 = 0;

dif = 1;
while dif > 1e-9,

    numerator = sum( abs(z).^2 ./ (iGamma + lambda0).^2 );
    denominator = (sum( abs(z).^2 ./ (iGamma + lambda0) )).^2;
    f = numerator/denominator - rho;
    
    num_der = -2 * sum( abs(z).^2 ./ (iGamma + lambda0).^3 );
    den_der = 2 * sum( abs(z).^2 ./ (iGamma +lambda0) ) *...
        ( -sum( abs(z).^2 ./ (iGamma + lambda0).^2 ) );
    f_der = ( num_der*denominator - numerator*den_der ) /...
        denominator^2;
    
    lambda1 = lambda0 - f/f_der;
    dif = abs(lambda1 - lambda0);
    lambda0 = lambda1;

end

% IS IT WORKING?
%numerator = sum( abs(z).^2 / (iGamma + lambda0).^2 );
%denominator = (sum( abs(z).^2 / (iGamma + lambda0) )).^2;
%f = numerator/denominator - rho

if (lambda0 < lblambda) | (lambda0 > ublambda),
    lambda0 = NaN;
end

% -------------------------------------------------------------
